/*
#include <iostream>
#include <winbgim.cpp>

using namespace std;

#define 	GENISLIK 	800
#define 	YUKSEKLIK 	600
#define 	ODAK 		500
#define 	PI 			3.14159

class Nokta{
	public:
		float x, y, z;
		float ni, nj, nk;
		float nmr;
		void Init(float X, float Y, float Z){
			x = X;
			y = Y;
			z = Z;
		}
		void Sifirla(){
			ni = 0;
			nj = 0;
			nk = 0;
		}
		void Hesapla(float a, float b, float c){
			ni += a;
			nj += b;
			nk += c;
		}
		void Bitir(){
			nmr = sqrt(ni*ni + nj*nj + nk*nk);
			ni /= nmr;
			nj /= nmr;
			nk /= nmr;
		}
};

Nokta 	*n, *nn, *tmp;

class Ucgen{
	public:
		int a, b, c;
		float ni, nj, nk;
		float Gz;
		void Init(int A, int B, int C){
			a = A;
			b = B;
			c = C;
		}
		void Hesapla(){
			float a1 = (nn[b].x - nn[a].x), 
				a2 = (nn[b].y - nn[a].y), 
				a3 = (nn[b].z - nn[a].z), 
				b1 = (nn[c].x - nn[a].x), 
				b2 = (nn[c].y - nn[a].y),
				b3 = (nn[c].z - nn[a].z);
			Gz = ( nn[a].z + nn[b].z + nn[c].z ) / 3;
			ni = a2*b3 - a3*b2;
			nj = a3*b1 - a1*b3;
			nk = a1*b2 - a2*b1;
			a1 = sqrt(ni*ni + nj*nj + nk*nk);
			ni /= a1;
			nj /= a1;
			nk /= a1;
		}
};

Ucgen 	*u;

bool nokta = false, dogru = true, boya = false, arka = false;
int alfa = 0, beta = 0;
bool click, ara = true, egik = true, isik = false, yarim = false, lamba = false;
int tmpClickX, tmpClickY;
int tmpX, tmpY;
float isikNi = 1.0, isikNj = 1.0, isikNk	= 1.0;

void click_handler(int a, int b){
	
	click = true;
	tmpClickX = a;
	tmpClickY = b;
	tmpX = alfa;
	tmpY = beta;
	
	if(b > 4 && b < 20){
		if(a > 4 && a < 20) nokta = !nokta;
		if(a > 24 && a < 40) dogru = !dogru;
		if(a > 44 && a < 60) boya = !boya;
		if(a > 64 && a < 80) arka = !arka;
		if(a > 84 && a < 100) egik = !egik;
		if(a > 104 && a < 120) ara = !ara;
		if(a > 124 && a < 140) yarim = !yarim;
		if(a > 144 && a < 160) isik = !isik;
		if(a > 164 && a < 180) lamba = !lamba;
		return;
	}
	
	if(lamba){
		isikNi = (a-400)/100.0;
		isikNj = (b-300)/100.0;
	}
}
void move_handler(int a, int b){
	if(!click)
		return;
	if(lamba){
		isikNi = (a-400)/100.0;
		isikNj = (b-300)/100.0;
		return; 
	}
	alfa 	= ((a-tmpClickX) + tmpX)%360;
	beta 	= ((b-tmpClickY) + tmpY)%360;
}
void up_handler(int a, int b){
	click = false;
}

void herZaman(){
	setcolor(15);
	for(int i=0; i<9; i++)
		rectangle(4+i*20, 4, 20+i*20, 20);
	setcolor(2);
	if(nokta)
		rectangle(8, 8, 16, 16);
	if(dogru)
		rectangle(28, 8, 36, 16);
	if(boya)
		rectangle(48, 8, 56, 16);
	if(arka)
		rectangle(68, 8, 76, 16);
	if(egik)
		rectangle(88, 8, 96, 16);
	if(ara)
		rectangle(108, 8, 116, 16);
	if(yarim)
		rectangle(128, 8, 136, 16);
	if(isik)
		rectangle(148, 8, 156, 16);
	if(lamba)
		rectangle(168, 8, 176, 16);
}

void Renk(int n){
	setcolor(n);
	setfillstyle(1, n);
}
		
void ucgenCiz(int a[], float nr[]){ // 16, 17, 18 --> Acilar
	int tmp[2], i, j;
	int col[3];
	for(i=a[1]; i<a[3]; i++){
		col[0] = (i-a[1])*(nr[17]-nr[16])/(a[3]-a[1]) + nr[16];
		col[1] = (i-a[1])*(nr[18]-nr[16])/(a[5]-a[1]) + nr[16];
		if(a[3]-a[1] == 0){
			tmp[0] = 0;
		}else{
			if(a[0] == a[2])
				tmp[0] = a[0];
			else{
				tmp[0] = (i-a[3])*(a[2]-a[0])/(a[3]-a[1])+a[2];
			}
		}
		if(a[5]-a[1] == 0){
			tmp[1] = 0;
		}else{
			if(a[4] == a[0])
				tmp[1] = a[0];
			else{
				tmp[1] = (i-a[5])*(a[4]-a[0])/(a[5]-a[1])+a[4];
			}
		}
		if(tmp[0] < tmp[1]){
			for(j=tmp[0]; j<tmp[1]; j++){
				col[2] = (j-tmp[0])*(col[1]-col[0])/(tmp[1]-tmp[0]) + col[0];
				putpixel(j,i,COLOR(255,col[2],0));
			}
		}else{
			for(j=tmp[1]; j<tmp[0]; j++){
				col[2] = (j-tmp[1])*(col[0]-col[1])/(tmp[0]-tmp[1]) + col[1];
				putpixel(j,i,COLOR(255,col[2],0));
			}
		}
	}
	for(i=a[3]; i<a[5]; i++){
		col[0] = (i-a[3])*(nr[18]-nr[17])/(a[5]-a[3]) + nr[17];
		col[1] = (i-a[1])*(nr[18]-nr[16])/(a[5]-a[1]) + nr[16];
		if(a[3]-a[5] == 0){
			tmp[0] = 0;
		}else{
			if(a[4] == a[2])
				tmp[0] = a[4];
			else{
				tmp[0] = (i-a[5])*(a[4]-a[2])/(a[5]-a[3])+a[4];
			}
		}
		if(a[5]-a[1] == 0){
			tmp[1] = 0;
		}else{
			if(a[4] == a[0])
				tmp[1] = a[4];
			else{
				tmp[1] = (i-a[5])*(a[4]-a[0])/(a[5]-a[1])+a[4];
			}
		}
		if(tmp[0] < tmp[1])
			for(j=tmp[0]; j<tmp[1]; j++){
				col[2] = (j-tmp[0])*(col[1]-col[0])/(tmp[1]-tmp[0]) + col[0];
				putpixel(j,i,COLOR(255,col[2],0));
			}
		else
			for(j=tmp[1]; j<tmp[0]; j++){
				col[2] = (j-tmp[1])*(col[0]-col[1])/(tmp[0]-tmp[1]) + col[1];
				putpixel(j,i,COLOR(255,col[2],0));
			}
	}
}

int main(){
	FILE 	*f;
	Ucgen tmpU;
	char dosya[] = "00.txt\0";
	float 	a[4], nrm[20], tpr;
	float isikM;
    int t = 0, NoktaSayisi, UcgenSayisi, boyanacak[6], ucgenC[6];
    int i, j, k , tmpr;
	float xGenislet, yGenislet, zGenislet;
	cout << " Obje Seciniz [ x.txt - (1, 2, ... , 9) ] : " ;
	cin >> t;
	dosya[0] = t/10 + '0';
	dosya[1] = t%10 + '0';
    f = fopen(dosya, "r");
	if( !f ){
		cout << endl << dosya << " Dosyasi Bulunamadi..." << endl << endl;
		system("PAUSE");
		return -1;
	}
	cout << "--------------------------------------" << endl;
	cout << dosya << " Dosyasi Okunuyor..." << endl;
	fscanf(f, "%f %f %f\n", &a[0], &a[1], &a[2]);
	xGenislet = a[0];
	yGenislet = a[1];
	zGenislet = a[2];
	fscanf(f, "%f\n", &a[3]);
	NoktaSayisi = (int)a[3];
	n = new Nokta[NoktaSayisi];
	nn = new Nokta[NoktaSayisi];
	tmp = new Nokta[NoktaSayisi];
	for(i=0; i<(int)a[3]; i++){
		fscanf(f, "%f %f %f\n", &a[0], &a[1], &a[2]);
		n[i].Init(xGenislet*a[0], yGenislet*a[1], zGenislet*a[2]);
	}
	fscanf(f, "%f\n", &a[3]);
	UcgenSayisi = (int)a[3];
	u = new Ucgen[UcgenSayisi];
	for(i=0; i<a[3]; i++){
		fscanf(f, "%f %f %f\n", &a[0], &a[1], &a[2]);
		u[i].Init((int)a[0], (int)a[1], (int)a[2]);
	}
	cout << "--------------------------------------" << endl;
    
    initwindow( GENISLIK, YUKSEKLIK );
    registermousehandler( WM_LBUTTONDOWN, click_handler );
	registermousehandler( WM_MOUSEMOVE, move_handler );
	registermousehandler( WM_LBUTTONUP, up_handler );
    while(!kbhit()){
		t = (t+1)%2;
		setactivepage(t%2);
		clearviewport();
		isikM = sqrt(isikNi*isikNi + isikNj*isikNj + isikNk*isikNk);
		for(i=0; i<NoktaSayisi; i++){
			tmp[i].Init(cos(alfa*PI/180)*n[i].x - sin(alfa*PI/180)*n[i].z,
						cos(alfa*PI/180)*n[i].y + (1-cos(alfa*PI/180))*n[i].y,
						cos(alfa*PI/180)*n[i].z + sin(alfa*PI/180)*n[i].x);
			
			nn[i].Init (cos(beta*PI/180)*tmp[i].x + (1-cos(beta*PI/180))*tmp[i].x,
						cos(beta*PI/180)*tmp[i].y + sin(beta*PI/180)*tmp[i].z,
						cos(beta*PI/180)*tmp[i].z - sin(beta*PI/180)*tmp[i].y);	
			nn[i].Sifirla();
			if(egik)
				nn[i].Init(ODAK*(nn[i].x)/(ODAK - nn[i].z), ODAK*(nn[i].y)/(ODAK - nn[i].z), nn[i].z);
		}
		for(i=0; i<UcgenSayisi; i++){
			u[i].Hesapla();
			nn[u[i].a].Hesapla(u[i].ni, u[i].nj, u[i].nk);
			nn[u[i].b].Hesapla(u[i].ni, u[i].nj, u[i].nk);
			nn[u[i].c].Hesapla(u[i].ni, u[i].nj, u[i].nk);
		}
		for(i=0; i<NoktaSayisi; i++){
			nn[i].Bitir();
		}
		for(i=0; i<UcgenSayisi; i++)
			for(int j=i+1; j<UcgenSayisi; j++)
				if(u[i].Gz > u[j].Gz){
					tmpU = u[i];
					u[i] = u[j];
					u[j] = tmpU;
				}
		if(boya)
			for(i=0; i<UcgenSayisi; i++){
				boyanacak[0] = (int)nn[u[i].a].x + GENISLIK/2;
				boyanacak[1] = (int)nn[u[i].a].y + YUKSEKLIK/2;
				boyanacak[2] = (int)nn[u[i].b].x + GENISLIK/2;
				boyanacak[3] = (int)nn[u[i].b].y + YUKSEKLIK/2;
				boyanacak[4] = (int)nn[u[i].c].x + GENISLIK/2;
				boyanacak[5] = (int)nn[u[i].c].y + YUKSEKLIK/2;
				nrm[0] = nn[u[i].a].ni;
				nrm[1] = nn[u[i].a].nj;
				nrm[2] = nn[u[i].a].nk;
				nrm[3] = nn[u[i].b].ni;
				nrm[4] = nn[u[i].b].nj;
				nrm[5] = nn[u[i].b].nk;
				nrm[6] = nn[u[i].c].ni;
				nrm[7] = nn[u[i].c].nj;
				nrm[8] = nn[u[i].c].nk;
				
				for(j=0; j<6; j++)
					ucgenC[j] = boyanacak[j];
					
				for(k=0; k<3; k++){
					for(j=k+1; j<3; j++){
						if(ucgenC[2*k+1] > ucgenC[2*j+1]){
							tmpr = ucgenC[2*k];   // 1
							ucgenC[2*k] = ucgenC[2*j];
							ucgenC[2*j] = tmpr;
							tmpr = ucgenC[2*k+1]; // 2
							ucgenC[2*k+1] = ucgenC[2*j+1];
							ucgenC[2*j+1] = tmpr;
							tpr = nrm[3*j];
							nrm[3*j] = nrm[3*k];
							nrm[3*k] = tpr;
							tpr = nrm[3*j+1];
							nrm[3*j+1] = nrm[3*k+1];
							nrm[3*k+1] = tpr;
							tpr = nrm[3*j+2];
							nrm[3*j+2] = nrm[3*k+2];
							nrm[3*k+2] = tpr;
						}
					}
					for(j=0; j<3; j++){
						nrm[12] = nrm[3*j]*isikNi;
						nrm[13] = nrm[3*j+1]*isikNj;
						nrm[14] = nrm[3*j+2]*isikNk;
						nrm[15] = sqrt(nrm[3*j]*nrm[3*j] + nrm[3*j+1]*nrm[3*j+1] + nrm[3*j+2]*nrm[3*j+2]);
						nrm[9+j] = (nrm[12]+nrm[13]+nrm[14])/(isikM*nrm[15]);
					}
				}
				nrm[15] = (42*(nrm[9]+nrm[10]+nrm[11] + 3));
				nrm[16] = (127*(nrm[9] + 1));
				nrm[17] = (127*(nrm[10] + 1));
				nrm[18] = (127*(nrm[11] + 1));
				if((u[i].nk > 0 || arka) && !isik){
					Renk(COLOR(0,0,0));
					fillpoly(3, boyanacak);
				}
				if(u[i].nk > 0 && isik){
					ucgenCiz(ucgenC, nrm);
				}
				if(dogru && yarim){
					setcolor(11);
					if(u[i].nk > 0 || arka){
						line(boyanacak[0], boyanacak[1], boyanacak[2], boyanacak[3]);
						line(boyanacak[4], boyanacak[5], boyanacak[2], boyanacak[3]);
						if(ara)
							line(boyanacak[4], boyanacak[5], boyanacak[0], boyanacak[1]);
					}
				}
			}
		if((dogru && !yarim) || (dogru && !boya))
			for(int i=0; i<UcgenSayisi; i++){
				boyanacak[0] = (int)nn[u[i].a].x + GENISLIK/2;
				boyanacak[1] = (int)nn[u[i].a].y + YUKSEKLIK/2;
				boyanacak[2] = (int)nn[u[i].b].x + GENISLIK/2;
				boyanacak[3] = (int)nn[u[i].b].y + YUKSEKLIK/2;
				boyanacak[4] = (int)nn[u[i].c].x + GENISLIK/2;
				boyanacak[5] = (int)nn[u[i].c].y + YUKSEKLIK/2;
				setcolor(11);
				if(u[i].nk > 0 || arka){
					line(boyanacak[0], boyanacak[1], boyanacak[2], boyanacak[3]);
					line(boyanacak[4], boyanacak[5], boyanacak[2], boyanacak[3]);
					if(ara)
						line(boyanacak[4], boyanacak[5], boyanacak[0], boyanacak[1]);
				}
			}
		setcolor(15);
		if(nokta)
			for(int i=0; i<NoktaSayisi; i++)
				rectangle((int)(nn[i].x-2) + GENISLIK/2, (int)(nn[i].y-2) + YUKSEKLIK/2, (int)(nn[i].x+2) + GENISLIK/2, (int)(nn[i].y+2) + YUKSEKLIK/2);
		herZaman();
		setvisualpage(t%2);
	}
    return 1;
}
*/
